/*
* Copyright © 2019, SAS Institute Inc., Cary, NC, USA.  All Rights Reserved.
* SPDX-License-Identifier: Apache-2.0
*/
/**
 * @async
 * @function setupAssist
 * @description   Setup the GPT Assistant
 * @param {string} apiKey - openai api key
 * @param {object} config - configuration object
 * @returns {promise} - return {openai, assistant, thread, functionList}
 */
async function createAssistant(openai, config) {
let {assistantName, instructions, model, specs} = config;
// Create a new thread(could have used an existing one, but not yet implemented)
let thread = await openai.beta.threads.create({
  metadata: {assistanceName: assistantName, lastRunId: '0'}}
);

let createArgs = {
  name: assistantName,
  instructions: instructions,
  model: model, 
  tools: specs.tools,
  metadata:{ thread_id: thread.id, lastRunId: '0'},
};
debugger;
let assistant = await openai.beta.assistants.create(createArgs);
console.log('-----------------------------------');
console.log('New Assistant: ', assistantName , assistant.id);
console.log('New Thread: ', thread.id);
console.log('-----------------------------------');
// for clarity
let gptControl = {openai, assistant, thread, specs};
return gptControl;
}
export default createAssistant;